'use strict';

var log = require('../utils/log');

module.exports = function (encoding) {
  return function (_ref) {
    var options = _ref.options,
        res = _ref.res;
    return new Promise(function (resolve, reject) {
      var body = [];
      res.on('data', function (chunk) {
        return body.push(chunk);
      }).on('end', function () {
        body = Buffer.concat(body);
        if (encoding !== null) {
          body = Buffer.from(body).toString(encoding);
        }
        log({ body });
        resolve({ options, res, body });
      }).on('error', reject);
    });
  };
};