'use strict';

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

var t = require('assert');
var http = require('http');

var compose = require('../');
var Request = compose.Request;
var Response = compose.Response;

describe('middlewares', function () {
  var server;

  before(function (done) {
    server = http.createServer();
    server.on('request', function (req, res) {
      res.writeHead(200, 'OK', {
        'content-type': 'application/json'
      });
      res.end(JSON.stringify({ a: 1 }));
    });
    server.listen(5000, done);
  });

  it('request', _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
    var _ref2, res, body;

    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.next = 2;
            return compose(Request.defaults(), Request.url('http://localhost:5000'), Request.send(), Response.buffer(), Response.parse())();

          case 2:
            _ref2 = _context.sent;
            res = _ref2.res;
            body = _ref2.body;

            t.equal(res.statusCode, 200);
            t.equal(res.statusMessage, 'OK');
            t.deepStrictEqual(body, { a: 1 });

          case 8:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, undefined);
  })));

  after(function (done) {
    return server.close(done);
  });
});