'use strict';

var t = require('assert');

var Request = {
  defaults: require('../../request/defaults')
};

describe('defaults', function () {

  it('defaults', function () {
    t.deepStrictEqual(Request.defaults()().options, {
      protocol: 'http:',
      hostname: 'localhost',
      port: 80,
      method: 'GET',
      path: '/',
      headers: {},
      timeout: 5000
    }, 'http.request defaults + 5s timeout');
  });

  it('override', function () {
    var args = {
      protocol: 'https:',
      hostname: 'website.com',
      port: 8080,
      method: 'POST',
      path: '/some/path?a=1&b=2',
      headers: { 'content-type': 'application/json' },
      timeout: 3000
    };
    t.deepStrictEqual(Request.defaults(args)().options, args, 'should override http.request defaults');
  });

  it('filter out non http.request options', function () {
    t.equal(Request.defaults()().options.json, undefined, 'non http.request options should be filtered out');
  });
});