'use strict';

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

var t = require('assert');
var stream = require('stream');

var Response = {
  buffer: require('../../response/buffer')
};

describe('buffer', function () {

  it('utf8 encoding by default', _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
    var options, res, _ref2, body;

    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            options = {};
            res = new stream.Readable();

            res._read = function (size) {/*noop*/};

            setTimeout(function () {
              res.emit('data', Buffer.from('hey'));
              res.emit('end');
            }, 0);

            _context.next = 6;
            return Response.buffer()({ options, res });

          case 6:
            _ref2 = _context.sent;
            body = _ref2.body;

            t.equal(body, 'hey', 'should buffer the response body');

          case 9:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, undefined);
  })));

  it('set specific encoding', _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2() {
    var res, _ref4, body;

    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            res = new stream.Readable();

            res._read = function (size) {/*noop*/};

            setTimeout(function () {
              res.emit('data', Buffer.from('hey'));
              res.emit('end');
            }, 0);

            _context2.next = 5;
            return Response.buffer('base64')({ res });

          case 5:
            _ref4 = _context2.sent;
            body = _ref4.body;

            t.equal(body, 'aGV5', 'should buffer the response body');

          case 8:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, undefined);
  })));

  it('binary data', _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3() {
    var res, input, _ref6, body;

    return regeneratorRuntime.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            res = new stream.Readable();

            res._read = function (size) {/*noop*/};

            input = Buffer.from('hey');

            setTimeout(function () {
              res.emit('data', input);
              res.emit('end');
            }, 0);

            _context3.next = 6;
            return Response.buffer(null)({ res });

          case 6:
            _ref6 = _context3.sent;
            body = _ref6.body;

            t.ok(input.equals(body), 'should buffer the response body');

          case 9:
          case 'end':
            return _context3.stop();
        }
      }
    }, _callee3, undefined);
  })));
});